From 24b1bb998f730e434d402a24a246937df8d124d3 Mon Sep 17 00:00:00 2001
From: Jonathan Hsieh <jon@cloudera.com>
Date: Fri, 17 Jun 2011 11:27:35 -0700
Subject: [PATCH] FLUME-665: Consolidate version numbers in maven build

---
 flume-config-web/pom.xml                |    4 +---
 flume-core/pom.xml                      |    2 --
 flume-distribution/pom.xml              |   18 ++++++++----------
 flume-docs/pom.xml                      |    2 --
 flume-log4j-appender/pom.xml            |    6 ++----
 flume-node-web/pom.xml                  |    6 ++----
 flume-windows-dist/pom.xml              |   13 ++++++-------
 plugins/flume-plugin-hbasesink/pom.xml  |    5 ++---
 plugins/flume-plugin-helloworld/pom.xml |    5 ++---
 9 files changed, 23 insertions(+), 38 deletions(-)

diff --git a/flume-config-web/pom.xml b/flume-config-web/pom.xml
index 75881a9..c8f3edd 100644
--- a/flume-config-web/pom.xml
+++ b/flume-config-web/pom.xml
@@ -9,9 +9,7 @@
     <version>0.9.4-SNAPSHOT</version>
   </parent>
 
-  <groupId>com.cloudera</groupId>
   <artifactId>flume-config-web</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <name>Flume Master Config Web Application</name>
   <packaging>war</packaging>
 
@@ -66,7 +64,7 @@
     <dependency>
       <groupId>com.cloudera</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
       <scope>provided</scope>
     </dependency>
 
diff --git a/flume-core/pom.xml b/flume-core/pom.xml
index 48f0446..fbd1d20 100644
--- a/flume-core/pom.xml
+++ b/flume-core/pom.xml
@@ -10,9 +10,7 @@
   </parent>
 
   <name>Flume Core</name>
-  <groupId>com.cloudera</groupId>
   <artifactId>flume-core</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
 
   <build>
     <plugins>
diff --git a/flume-distribution/pom.xml b/flume-distribution/pom.xml
index 3a93f67..bb9be1e 100644
--- a/flume-distribution/pom.xml
+++ b/flume-distribution/pom.xml
@@ -9,9 +9,7 @@
     <version>0.9.4-SNAPSHOT</version>
   </parent>
 
-  <groupId>com.cloudera</groupId>
   <artifactId>flume-distribution</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <packaging>pom</packaging>
   <name>Flume Distribution Project</name>
   <description>A module to handle all distribution packaging and assembly.</description>
@@ -46,29 +44,29 @@
   <dependencies>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-config-web</artifactId>
       <type>war</type>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-node-web</artifactId>
       <type>war</type>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-docs</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
   </dependencies>
diff --git a/flume-docs/pom.xml b/flume-docs/pom.xml
index 4b8bad6..f6f5b22 100644
--- a/flume-docs/pom.xml
+++ b/flume-docs/pom.xml
@@ -10,9 +10,7 @@
   </parent>
 
   <name>Flume Docs</name>
-  <groupId>com.cloudera</groupId>
   <artifactId>flume-docs</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
 
   <build>
     <plugins>
diff --git a/flume-log4j-appender/pom.xml b/flume-log4j-appender/pom.xml
index f587a84..353831d 100644
--- a/flume-log4j-appender/pom.xml
+++ b/flume-log4j-appender/pom.xml
@@ -25,17 +25,15 @@
     <version>0.9.4-SNAPSHOT</version>
   </parent>
 
-  <groupId>com.cloudera</groupId>
   <artifactId>flume-log4j-appender</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <name>A log4j appender for Flume</name>
 
   <dependencies>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
diff --git a/flume-node-web/pom.xml b/flume-node-web/pom.xml
index fb670fb..3d79af8 100644
--- a/flume-node-web/pom.xml
+++ b/flume-node-web/pom.xml
@@ -10,9 +10,7 @@
   </parent>
 
   <name>Flume Node Web</name>
-  <groupId>com.cloudera</groupId>
   <artifactId>flume-node-web</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <packaging>war</packaging>
 
   <build>
@@ -54,9 +52,9 @@
   <dependencies>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
       <scope>provided</scope>
     </dependency>
 
diff --git a/flume-windows-dist/pom.xml b/flume-windows-dist/pom.xml
index 466f4dc..5fec750 100644
--- a/flume-windows-dist/pom.xml
+++ b/flume-windows-dist/pom.xml
@@ -11,7 +11,6 @@
 
   <groupId>com.cloudera</groupId>
   <artifactId>flume-windows-dist</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <packaging>pom</packaging>
   <name>Flume Windows Distribution</name>
   <description>A module to handle all distribution packaging and
@@ -67,23 +66,23 @@
   <dependencies>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-config-web</artifactId>
       <type>war</type>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-node-web</artifactId>
       <type>war</type>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
   </dependencies>
diff --git a/plugins/flume-plugin-hbasesink/pom.xml b/plugins/flume-plugin-hbasesink/pom.xml
index 26d7f54..c98f5ca 100644
--- a/plugins/flume-plugin-hbasesink/pom.xml
+++ b/plugins/flume-plugin-hbasesink/pom.xml
@@ -11,15 +11,14 @@
   <modelVersion>4.0.0</modelVersion>
   <groupId>com.cloudera.flume.plugin</groupId>
   <artifactId>flume-plugin-hbasesink</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <name>Flume HBase Plugin</name>
 
   <dependencies>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
     <dependency>
diff --git a/plugins/flume-plugin-helloworld/pom.xml b/plugins/flume-plugin-helloworld/pom.xml
index aec0fb9..94021b8 100644
--- a/plugins/flume-plugin-helloworld/pom.xml
+++ b/plugins/flume-plugin-helloworld/pom.xml
@@ -11,16 +11,15 @@
 
   <groupId>com.cloudera.flume.plugin</groupId>
   <artifactId>flume-plugin-helloworld</artifactId>
-  <version>0.9.4-SNAPSHOT</version>
   <name>Flume Hello World Plugin</name>
   <description>An example hello world plugin for Flume</description>
 
   <dependencies>
 
     <dependency>
-      <groupId>com.cloudera</groupId>
+      <groupId>${project.parent.groupId}</groupId>
       <artifactId>flume-core</artifactId>
-      <version>0.9.4-SNAPSHOT</version>
+      <version>${project.parent.version}</version>
     </dependency>
 
   </dependencies>
-- 
1.7.1